import React from 'react'
import {Form, Icon, Input, Button, message} from 'antd'
import {withRouter} from "react-router-dom";
import {set, setObj,clear} from "../../service/Global";
import HttpClient from '../../service/HttpClient'
import Api from '../../service/Api'
import Base64 from 'base-64'
import './Login.scss'
@withRouter
class LoginTpl extends React.Component{
    constructor(props){
        super(props)
        this.state={
            loginType:0,
            display:0,
            inputValue:''
        }
    }
    handleSubmit = (e) => {
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                this.loginTo(values);
            }
        });
    };
    loginTo(values){
        HttpClient.post(Api.login,values).then(data => {
          if(data){
                setObj('login_info',data);
                set('token', data.token);
                //set('role', data.role);
                // set('overdue_data', Date.now() + 1000*60*60*24);
                // set('scanCode',data.scanCode)
                this.props.history.push('/');
            }
        })
    }

    // componentDidMount() {
    //     clear();
    // }
    componentWillMount(){
       
    }

    componentDidMount(){
        
       
       
        
        
    }
    handleType=(e)=>{
        e.preventDefault();
        this.setState({
            loginType:0,
            display:0
        })
    }
    // 获取input的值
    handleChange=(e)=>{
        console.log(e.target.value)
        this.setState({
            inputValue:e.target.value
        })
    }
    // 发送验证码
    handleSendCode=()=>{
        let inputValue=this.state.inputValue;
        if(inputValue==''){
            message.info('请先输入手机号！');
            return;
        }
        HttpClient.get(Api.sendCode,{phone:inputValue}).then(data => {
            console.log(data)
          })
    }

    render() {
        const { getFieldDecorator } = this.props.form;
        return(
            <section>
                <div className="login_panel">
                    <div className="title">聚合管理后台</div>
                    <div className='tab'>
                        <a href="#" className={this.state.display==0?'first active':'first'} onClick={this.handleType}>手机号登录</a>
                    </div>
                    <Form onSubmit={this.handleSubmit} className="login-form" style={{display:this.state.loginType==0?'block':'none'}}>
                        <Form.Item>
                                {getFieldDecorator('phone', {
                                    rules: [{ required: true, message: '请输入手机号!' },{
                                        pattern:/^1[3|4|5|7|8][0-9]\d{8}$/, message: '请输入正确的手机号'
                                    }],
                                })(
                                    <Input  placeholder="请输入手机号" onChange={this.handleChange}/>
                                )}
                                </Form.Item>
                                <Form.Item>
                                        {getFieldDecorator('pwd', {
                                            rules: [{ required: true, message: '请输入验证码!' }],
                                        })(
                                            <div style={{display:'flex'}}>
                                                <Input   placeholder="请输入验证码" />
                                                <Button type='primary' style={{marginLeft:'10px'}} onClick={this.handleSendCode}>发送验证码</Button>
                                            </div>
                                        )}
                                        </Form.Item>
                                        <Button type="primary" htmlType="submit" className="login-form-button">
                                                登录
                                        </Button>
                                    </Form>
                                </div>
                            </section>
        )
    }
}
const Login = Form.create({ name: 'login' })(LoginTpl);
export default Login;
